"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Components:
const React = require("react");
const classnames_1 = require("classnames");
const getClassNames_1 = require("../../utils/getClassNames");
exports.Button = React.memo(props => {
    const { bg, btnProps, children, className, color, disabled, loading, onClick, hollow, ripple, style, type } = props, styleProps = __rest(props
    // Hook:
    , ["bg", "btnProps", "children", "className", "color", "disabled", "loading", "onClick", "hollow", "ripple", "style", "type"]);
    // Hook:
    const btnRef = React.useRef(null);
    // Styles:
    let border = 'border-transparent';
    let background = 'bg-transparent';
    let text = `text-${color}`;
    switch (true) {
        case hollow:
            background = classnames_1.default(`bg-transparent `, !disabled && `hover:bg-${bg}`);
            text = classnames_1.default(`text-${bg}`, !disabled && `hover:text-${color}`);
            border = `border-${bg}`;
            break;
        default:
            background = classnames_1.default(`bg-${bg} `, !disabled && `hover:bg-${bg}-dark`);
            text = `text-${color}`;
    }
    const styleOptions = [background, border, text];
    const createRipple = (e) => {
        try {
            const btn = btnRef.current;
            if (btn) {
                if (btn.getElementsByClassName('Button-ripple').length > 0) {
                    btn.getElementsByClassName('Button-ripple')[0].remove();
                }
                const circle = document.createElement('div');
                btn.appendChild(circle);
                const rect = btn.getBoundingClientRect();
                const d = Math.max(btn.clientHeight, btn.clientWidth);
                circle.style.width = circle.style.height = d + 'px';
                circle.style.left = e.clientX - rect.left - d / 2 + 'px';
                circle.style.top = e.clientY - rect.top - d / 2 + 'px';
                circle.classList.add('Button-ripple');
            }
        }
        catch (error) {
            console.log('ripple effect not working.');
        }
    };
    const handleClick = (e) => {
        if (!disabled && !loading) {
            ripple && createRipple(e);
            onClick && onClick(e);
        }
    };
    return (React.createElement("button", Object.assign({ className: classnames_1.default(className && className, 'Button focus:outline-none transition', loading && 'spinner', hollow && 'outline', disabled && 'cursor-not-allowed disabled', styleOptions, getClassNames_1.getClassNames(styleProps)), onClick: handleClick, ref: btnRef, style: style && style, type: type }, btnProps), !loading && children));
});
exports.Button.defaultProps = {
    bg: 'first',
    color: 'white',
    position: 'relative',
    overflow: 'hidden ',
    ripple: false,
    type: 'button'
};
