"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Components:
const React = require("react");
const classnames_1 = require("classnames");
const Box_1 = require("../Box");
// ================================================================================================
const convertNum = (num) => {
    switch (num.trim()) {
        case '1':
            return '1/12';
        case '2':
            return '1/6';
        case '3':
            return '1/4';
        case '4':
            return '1/3';
        case '5':
            return '5/12';
        case '6':
            return '1/2';
        case '7':
            return '7/12';
        case '8':
            return '2/3';
        case '9':
            return '3/4';
        case '10':
            return '5/6';
        case '11':
            return '11/12';
        default:
            return 'full';
    }
};
const getOffset = (offset) => {
    if (!offset)
        return null;
    let cols = offset.split(',');
    cols = cols.map(col => {
        let str = col.split(':');
        let num = str.length > 1 ? str[1] : str[0];
        num = convertNum(num);
        return str.length > 1 ? `${str[0].trim()}:${num}` : num;
    });
    return cols.reduce((prev, cur) => {
        return prev + ',' + cur;
    });
};
exports.Col = React.memo(props => {
    const { children, className, width, offset, px, style } = props, styleProps = __rest(props, ["children", "className", "width", "offset", "px", "style"]);
    return (React.createElement(Box_1.Box, Object.assign({ basis: width, className: classnames_1.default('Col', className && className), style: style, px: px, ml: getOffset(offset) }, styleProps), children));
});
exports.Col.defaultProps = {
    width: 'default',
    display: 'block',
    px: '4',
    w: null
};
