"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Components:
const React = require("react");
const classnames_1 = require("classnames");
exports.Radio = React.memo(({ checked, className, id, label, name, onCheck, small, style, value }) => {
    const keyCode = {
        SPACE: 32
    };
    const keyDownHandler = (e) => {
        if (e.keyCode === keyCode.SPACE && onCheck) {
            !checked && onCheck();
            e.preventDefault();
        }
    };
    return (React.createElement("div", { "aria-checked": checked || false, className: classnames_1.default(`Radio flex justify-start items-center focus:outline-none`, small && 'small', checked && 'checked', className && className), onKeyDown: keyDownHandler, role: "radio", style: style, tabIndex: checked ? 0 : -1 },
        React.createElement("div", { className: classnames_1.default('Radio-button relative  rounded-1/2  hover:cursor-pointer'), id: id, onClick: onCheck },
            React.createElement("div", { className: classnames_1.default(`Radio-dot absolute t-1/2 l-1/2 rounded-1/2 opacity-${checked ? '100' : '0'} transition`) }),
            React.createElement("input", { type: "radio", name: name, value: value, defaultChecked: checked, className: "Radio-input hidden" })),
        React.createElement("label", { className: classnames_1.default(`Radio-label hover:cursor-pointer`), htmlFor: id, onClick: onCheck }, label)));
});
