"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Components:
const React = require("react");
const classnames_1 = require("classnames");
const { useEffect, useState } = React;
const scrollTop = () => {
    window.scroll({ top: 0, behavior: 'smooth' });
};
exports.ScrollTop = React.memo(({ className, color, icon, size, showAfter, style }) => {
    const [show, setShow] = useState(false);
    const showButton = () => {
        const doc = document.documentElement;
        const top = (window.pageYOffset || doc.scrollTop) - (doc.clientTop || 0);
        if (show !== top > showAfter)
            setShow(top > showAfter);
    };
    useEffect(() => {
        window.addEventListener('scroll', showButton);
        return () => {
            window.removeEventListener('scroll', showButton);
        };
    }, [show]);
    const scrolltopIcon = icon ? (icon) : (React.createElement("div", { className: "ScrollTop-icon mt-px w-3 h-3 border-white rotate-45 border-t-2 border-l-2" }));
    return (React.createElement("div", { className: classnames_1.default(`ScrollTop w-${size} h-${size} bg-${color} hover:bg-${color}-dark fixed rounded-1/2 b-2 r-2 flex justify-center items-center cursor-pointer transition`, show ? 'visible scale-100' : 'invisible  scale-0', className && className), onClick: scrollTop, style: style }, scrolltopIcon));
});
exports.ScrollTop.defaultProps = {
    color: 'first',
    showAfter: 200,
    size: 10
};
